program fusies;
{ fusiegolf: opgave 23 oktober 99 }
{ invoer: N = aantal companies (impliciet namen 1..N),
          N begingrootten (van comp 1..N),
          N-1 fusies ( paren (a,b), uit 1..N)
          bij fusie gaat geheel verder onder de laagste naam.
  uitvoer:volgorde van de companies waarbij fusie steeds plaats
          vindt tussen buren, en grootste voorop staat.
}
uses
  SysUtils;
const maxN = 4000;
type Pcomp = ^Tcomp;
     Tcomp = record
               nr: integer;     {'naam' van de company    }
               weight: longint; { grootte, kan 1 zijn     }
               second: Pcomp;   { opvolger in conglomeraat}
               last: Pcomp      { laatste in dit lijstje  }
             end;
var  N, nr: integer;
     NC: integer;      { aantal companies }
     comp: array[1..maxN] of Pcomp;
     { comp[a]^ is de kop van de gelinkte lijst die de companies bevat
       die opgegaan zijn in a. Voor het eenvoudig aan elkaar koppelen
       wordt ook de staart van de lijst bijgehouden }
     a, b: integer; { fusiepartners }
     p   : Pcomp;
     i, k: integer;
     inp, uit: text; { invoer en uitvoer }

procedure Error(  s: string );
  begin writeln(s);
      write('Enter to dismiss window ');
      readln; halt
  end;

begin { main }
  readln( N );

for nr := 1 to N do begin
  readln( NC );
  if (NC <1 )or(NC > maxN) then  Error('verkeerde grootte ');
  for k:=1 to NC do begin
      new(comp[k]);  { claim ruimte voor dit gegevensblokje }
      with comp[k]^ do begin
          nr := k;        { alle zelfstandig }
          read( weight ); { beginwaarde/omvang o.i.d. }
          second := NIL ; { alle zelfstandig, dus geen volgende in lijst}
          last := comp[k] { de lijst bestaat nu uit EEN company }
      end;
  end;

  for i:=1 to NC-1 do begin
    readln( a, b); { fusie tussen a en b: geheel gaat verder
                          onder naam: minimum van a en b }
    if (comp[a] = NIL ) or (comp[b] = NIL ) then
    Error( ' company bestaat niet meer ');
    if a = b then Error(' zelffusie! ');
    if a > b then begin k:=a; a:=b; b:=k end;
    { a is nu laagste nummer, b hoogste ]
      de lijsten van a en b worden aan elkaar gekoppeld }
    if comp[a]^.weight >= comp[b]^.weight then begin
       { a moet voorop in de lijst }
       comp[a]^.weight:=comp[a]^.weight+comp[b]^.weight;
       comp[b]^.weight := 0;
       comp[a]^.last^.second := comp[b];
       comp[a]^.last := comp[b]^.last;
       comp[b] := NIL
    end else begin { b moet voorop, maar a is de naam }
       if comp[a]^.weight = comp[b]^.weight then
          writeln('Let op: comp ',a,' even groot als ',b);
       comp[b]^.weight:=comp[a]^.weight+comp[b]^.weight;
       comp[a]^.weight := 0;
       comp[b]^.last^.second := comp[a];
       comp[b]^.last := comp[a]^.last;
       comp[a] := comp[b]; comp[b] := NIL
    end
  end;

  for k:=1 to NC do if comp[k] <> NIL then begin
      p := comp[k]; i:=0;
      repeat
          write( p^.nr, ' ' ); i:=i+1;
          p := p^.second
      until  p = NIL;
      writeln( )
  end;
end; { for nr:=1 to N }
{  writeln;
   write('Enter to dismiss window'); readln }
end.

